#!/usr/bin/perl -w

use IO::Socket;

use Deliv;

use constant status_up => 1;
use constant status_corrupt => 2;
use constant status_mumble => 3;
use constant status_down => 4;


#open(FILE,">>log.txt");


checker();


sub checker{

    $action = shift @ARGV;
    $addr = shift @ARGV;

    if($action eq "check"){
        exit check_service();
        }

    $id = shift @ARGV;
    $key = shift @ARGV;

    if($action eq "put"){
        exit put_flag($id,$key);
        }

    if($action eq "get"){
        exit get_flag($id,$key,"check");
        }

    print "unknow option $action\n";
    exit 5;
}


sub check_service{

    my $vuln_count = 0;
    my $i;
    my $buf;

    my $sock = IO::Socket::INET->new("$addr:$port") or return status_down;

    read($sock,$buf,$hello_len);

    print $sock "action:put\nid:" . get_random_id() . "\n";
    for($i=0;$i<8;$i++){
        print $sock get_random_deliv(8).":".get_random_deliv(8) . "\n";
        }
    print $sock "\n";
    <$sock>;
    read($sock,$buf,6);
    close($sock);
    if($buf ne "check\n"){
        print "error check\n";
        return status_mumble;
        }

    for($i=1;$i<=5;$i++){
        system("./exp.pl $addr $i");
        $vuln_count++ if($? == 0);
        }
    print "$vuln_count vuln available\n";

    my $id = get_random_id();
    my $flag = get_random_flag(500);

    my $res = put_flag($id,$flag);
    if($res != status_up){
        return $res;
        }

    return get_flag($id,$flag,"get");
}

sub put_flag
{

    my $id = shift @_;
    my $key = shift @_;

    my $sock = IO::Socket::INET->new("$addr:$port") or return status_down;
    $sock->autoflush(1);

    read($sock,$buf,$hello_len);

    print $sock "action:put\n";
    print $sock "id:$id\n";
    print $sock "key:$key\n\n";

    $buf = <$sock>;

    close($sock);

    if($buf =~ /success/){
        return status_up;
        }
    else{
        print "Answer no success\n";
        return status_mumble;
        }
}

sub get_flag
{

    my $id = shift @_;
    my $key = shift @_;
    my $method = shift @_;

    my $sock = IO::Socket::INET->new("$addr:$port") or return status_down;
    $sock->autoflush(1);

    read($sock,$buf,$hello_len);

    print $sock "action:$method\n";
    print $sock "id:$id\n";

    $aid = <$sock>;
    $akey = <$sock>;

    close($sock);

    if( ($aid =~ /id:(.+)\n/) &&
        ($1 eq $id) ){
        if( ($akey =~ /key:(.+)\n/) &&
            ($1 eq $key) ){
            return status_up;
            }
        else{
            print "Error flag\n";
            return status_corrupt;
            }
        }
    else{
        if($aid =~ /Delivery no exist/){
            print "No flag\n";
            return status_corrupt;
            }
        else{
            print "Error get flag\n";
            return status_mumble;
            }
        }
}

