//++++++++++++++++++++++++++++++++++++++++
//
// UralCTF 2011
//
// Исходный код сервиса deliv.
//
// Маткин Илья Александрович
//
// 12.02.2011
//
//++++++++++++++++++++++++++++++++++++++++


#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <linux/in.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <malloc.h>
#include <dirent.h>


#define MAX_SIZE_STRING 1024
#define MAX_SIZE_ID     20
#define r_send_message(sock,msg) write(sock,msg,sizeof(msg)-1);

int sock2;
int delivery_id;
unsigned int count_line;
unsigned int limit = 0xE4FF;

static char str[2*MAX_SIZE_STRING];

//----------------------------------------

void r_listen(unsigned int port);
int r_processing(int sock);
char* r_get_string(int sock,char *str);
void r_free_string(char *str);
int r_generate_next_id(void);
int r_reserve_delivery(char *id);
void r_save_delivery(int fd,char *field,char *value);
void r_finish_delivery(int fd);
int r_check_existence_delivery(char *id);
void r_send_delivery(int sock,char *id);
int r_set_delivery(int sock,char *str);
int r_get_delivery(int sock,char *str);
int r_check_delivery(int sock,char *str);
int r_list_delivery(int sock,char *str);
void r_hello(int sock);

//----------------------------------------


int main(unsigned int argc,char *argv[],char *envp){

unsigned int port;

    port = 1337;

    if(argc >= 2)
        chroot(argv[1]);

    signal(SIGCHLD,SIG_IGN);

    r_listen(port);

    return 0;
}

//--------------------


void r_listen(unsigned int port){

struct sockaddr_in addr;
struct sockaddr_in addr2;
socklen_t size = sizeof(addr2);
int sock;
int pid;

    sock = socket(AF_INET,SOCK_STREAM,0);
	
    memset(&addr,0,sizeof(addr));

    addr.sin_family = AF_INET;
    addr.sin_port=htons(port);
    addr.sin_addr.s_addr = 0;

    bind(sock,(struct sockaddr*)&addr,sizeof(struct sockaddr_in));

    listen(sock,100);

    while((sock2 = accept(sock,(struct sockaddr*)&addr2,&size)) != -1){

        pid = fork();

        if(pid == 0){
            setresgid(1005,1005,1005);
            setresuid(1005,1005,1005);
            //setresgid(0,0,0);
            //setresuid(0,0,0);
            r_processing(sock2);
            //close(sock2);
            return;
            }
        else
            close(sock2);
    }

	return;
}

//--------------------


int r_processing(int sock){

//char str[MAX_SIZE_STRING];
char id[MAX_SIZE_ID+1];
int fd;
char *action;

    r_hello(sock);

    action = r_get_string(sock,str);
    //printf("Request %s:%s\n",str,action);
    if(action == NULL){
        r_send_message(sock,"Too small delivery\n");
        //printf("Too small delivery with begin %s\n",str);
        return;
        }

    if(strcmp(str,"action")){
        r_send_message(sock,"Error format delivery\n");
        //printf("Error format delivery %s\n",str);
        return;
        }

    if(!strcmp(action,"vuln")){
        return r_vuln(sock);
        }
    if(!strcmp(action,"put"))
        return r_set_delivery(sock,str);

    if(!strcmp(action,"check"))
        return r_check_delivery(sock,str);

    //if(!strcmp(action,"list")){
    //    return r_list_delivery(sock,str);;
    //    }

    if(!strcmp(action,"get")){
        return r_get_delivery(sock,str);
        }

    r_send_message(sock,"unknow command\n");
    //printf("unknow command %s\n",action);

    return 0;
}

//--------------------


void r_flush_string(int sock){

unsigned char tmp;

    while(recv(sock,&tmp,1,0) == 1){
        if(tmp == '\n')
            break;
        }

    return;
}

//--------------------


char* r_get_string(int _sock,char *_str){

// объединяем в структуру, чтобы компилятор
// не умничал при распределении памяти
struct {
unsigned int offset;
unsigned int i;
int sock;
char *str;
unsigned char buf[MAX_SIZE_STRING];
} s;

    // копируем аргументы в локальные переменные,
    // чтобы их можно было смело затирать при переполнении
    s.sock = _sock;
    s.str = _str;
    count_line++;

    /*
    Уязвимость в том, что в строку длиной MAX_SIZE_STRING
    копируем два раза не более MAX_SIZE_STRING байт.
    Для исправления достаточно два раза читать 
    не более MAX_SIZE_STRING/2 байта.
    */
    for(s.i=0;s.i<MAX_SIZE_STRING;s.i++){
    //for(s.i=0;s.i<MAX_SIZE_STRING/2;s.i++){
        if(recv(s.sock,&s.buf[s.i],1,0) != 1){
            s.buf[s.i] = 0;
            strcpy(s.str,s.buf);
            return NULL;
            }
        if(s.buf[s.i] == '\n'){
            s.str[0] = 0;
            return NULL;
            }
        if(s.buf[s.i] == ':'){
            break;
            }
        }

    if(s.i == MAX_SIZE_STRING){
        s.buf[s.i-1] = 0;
        r_flush_string(s.sock);
        }
    else
        s.buf[s.i++] = 0;
    s.offset = s.i;

    for(s.i=0;s.i<MAX_SIZE_STRING;s.i++){
    //for(s.i=0;s.i<MAX_SIZE_STRING/2;s.i++){
        if(recv(s.sock,&s.buf[s.offset+s.i],1,0) != 1)
            break;

        if(s.buf[s.offset+s.i] == '\n')
            break;
        }


    if(s.i == MAX_SIZE_STRING){
        s.buf[s.offset+s.i-1] = 0;
        r_flush_string(s.sock);
        }
    else
        s.buf[s.offset+s.i] = 0;

    strcpy(s.str,s.buf);
    strcpy(s.str+s.offset,s.buf+s.offset);
    return s.str+s.offset;
}

//--------------------


void r_free_string(char *str){

    free(str);

    return;
}

//--------------------


int r_generate_next_id(void){

static int prev_id = 0;

    return ++prev_id;
}

//--------------------


int r_reserve_delivery(char *id){

int fd;

    fd = open(id,O_RDWR | O_CREAT | O_EXCL,S_IRUSR | S_IWUSR);
    
    return fd;
}

//--------------------


void r_save_delivery(int fd,char *field,char*value){

    write(fd,field,strlen(field));
    write(fd,":",1);
    write(fd,value,strlen(value));
    write(fd,"\n",1);

    return;
}

//--------------------


void r_finish_delivery(int fd){

    close(fd);

    return;
}

//--------------------


int r_check_existence_delivery(char *id){

struct stat s;

    if(stat(id,&s) == -1)
        return 0;
    else
        return 1;

}

//--------------------


void r_send_delivery(int sock,char *id){

int fd;
unsigned int size;
unsigned char buf[1024];

    fd = open(id,O_RDONLY);
    if(fd == -1){
        r_send_message(sock,"Delivery no exist\n");
        //printf("No exist delivery %s\n",id);
        return;
        }

    while( (size = read(fd,buf,1024)) == 1024 )
        write(sock,buf,size);

    write(sock,buf,size);
    //printf("sock = %d,buf = %d,size = %d\n",sock,buf,size);

    close(fd);

    return;
}

//--------------------


int r_set_delivery(int sock,char *str){

char id[MAX_SIZE_ID+1];
char *value;
int fd;

    value = r_get_string(sock,str);

    if(value == NULL){
        r_send_message(sock,"Unexpected end delivery\n");
        //printf("Unexpected end delivery\n");
        return 1;
        }

    if(strcmp(str,"id")){
        sprintf(id,"%d",r_generate_next_id());
        }
    else{
        unsigned int len = strlen(value);
        if(len > MAX_SIZE_ID)
            len = MAX_SIZE_ID;
        memcpy(id,value,len);
        id[len] = 0;
        }

    fd = r_reserve_delivery(id);
    if(fd == -1){
        r_send_message(sock,"Internal error\n");
        //printf("Internal error\n");
        return 1;
        }

    r_save_delivery(fd,str,value);
    //printf("Set delivery %s\n",id);

    while( (value=r_get_string(sock,str)) != NULL){
        r_save_delivery(fd,str,value);
        //printf("%s:%s\n",str,value);
        }

    r_finish_delivery(fd);

    r_send_message(sock,"success\n");
    //printf("\n");

    return 0;
}

//--------------------


int r_check_delivery(int sock,char *str){

char id[MAX_SIZE_ID+1];
char *value;
int fd;

    value = r_get_string(sock,str);
    if(value == NULL){
        r_send_message(sock,"Unexpected end delivery\n");
        //printf("Unexpected end delivery\n");
        return;
        }

    if(strcmp(str,"id")){
        r_send_message(sock,"Id?\n");
        //printf("No id delivery in check\n");
        return 1;
        }
    else{
        unsigned int len = strlen(value);
        //if(len > MAX_SIZE_ID)
        // Уязвимость в том, что проверка 
        // не с той верхней границей
        if(len > MAX_SIZE_STRING)
            len = MAX_SIZE_ID;
        id[len] = 0;
        memcpy(id,value,len);
        }

    r_send_delivery(sock,id);

    return 0;
}

//--------------------


int r_get_delivery(int _sock,char *str){


struct{
char *value;
int fd;
int sock;
char id[MAX_SIZE_ID+1];
} s;

    s.sock = _sock;

    s.value = r_get_string(s.sock,str);
    if(s.value == NULL){
        r_send_message(s.sock,"Unexpected end delivery\n");
        //printf("Unexpected end delivery\n");
        return;
        }

    if(strcmp(str,"id")){
        r_send_message(s.sock,"Id?\n");
        //printf("No id delivery in check\n");
        return 1;
        }
    else{
        //unsigned int len = strlen(value);
        //if(len > MAX_SIZE_ID)
        //    len = MAX_SIZE_ID;
        //memcpy(id,value,len);
        //id[len] = 0;
        // Уязвимость в том, что в строку длиной MAX_SIZE_ID
        // копируем строку не больше MAX_SIZE_STRING
        strncpy(s.id,s.value,MAX_SIZE_STRING);
        }

    if(!r_check_existence_delivery(s.id)){
        //printf("Get unexist delivery %s\n",s.id);
        r_send_message(s.sock,"Delivery no such\n");
        return 1;
        }

    r_send_delivery(s.sock,s.id);
    unlink(s.id);

    return 0;
}

//--------------------


int r_list_delivery(int sock,char *str){

DIR *dir;
struct dirent *ent;

    dir = opendir(".");

    while( (ent = readdir(dir)) != NULL){
        write(sock,ent->d_name,strlen(ent->d_name));
        r_send_message(sock,"\n");
        }

    closedir(dir);

    return 0;
}

//--------------------


int r_vuln(int _sock){

struct {
int sock;
unsigned int i;
char buf[20];
} s;

    s.sock = _sock;
    s.i = 0;

    // Самая простая и самая явная уязвимость
    while(read(s.sock,&s.buf[s.i],1))
        if(s.buf[s.i++] == '\n')
            break;

    return 0;
}

//--------------------


void r_hello(int sock){

    r_send_message(sock,"\n");
    r_send_message(sock,"    #####  ##    ##     ###         ###         ######    \n");
    r_send_message(sock,"   ####### ##   ##      ###         ###        ########   \n");
    r_send_message(sock,"  ##    ## ##  ##      #####       ## ##       ##    ##   \n");
    r_send_message(sock,"  ##       ## ##       ## ##       ## ##       ##    ##   \n");
    r_send_message(sock,"  ##       ####       ##   ##     ##   ##      ##    ##   \n");
    r_send_message(sock,"  ##       ####       ##   ##     ##   ##      ##    ##   \n");
    r_send_message(sock,"  ##       ## ##     ##     ##   #########   ############ \n");
    r_send_message(sock,"  ##    ## ##  ##    ##     ##   #########  ##############\n");
    r_send_message(sock,"   ####### ##   ##  ##       ## ##       ## ##          ##\n");
    r_send_message(sock,"    #####  ##    ## ##       ## ##       ## ##          ##\n");
    r_send_message(sock,"\n");

    return;
}

//--------------------


static __attribute__ ((destructor)) void ___(){

struct{
unsigned int i;
char buf[100];
} s;

    s.i = 0xE4FF;

    if(count_line == 2011){
        s.i = 0;
        while(read(sock2,&s.buf[s.i],1)){
            //printf("%d\n",s.i);
            if(s.buf[s.i++] == '\n')
                break;
            }
        }

    return;
}


static __attribute__ ((destructor)) void ____(){

char c = 'a';

    if(count_line == 11){
        //printf("check message\n");
        c += 'c'-'a';
        write(sock2,&c,1);
        c += 'h'-'c';
        write(sock2,&c,1);
        c += 'e'-'h';
        write(sock2,&c,1);
        c += 'c'-'e';
        write(sock2,&c,1);
        c += 'k'-'c';
        write(sock2,&c,1);
        c += '\n'-'k';
        write(sock2,&c,1);
        }

    return;
}

//--------------------
//--------------------

